/**
 * Created by hanngu on 13.02.15.
 */
public class MandlEdge {
    private MandlNode mandlNode1, mandlNode2;
    private int travelTime, demand;
    private double pheromone, probability, edgeValue;
    private boolean copy;

    public MandlEdge(MandlNode mandlNode1, MandlNode mandlNode2, int demand){
        this.mandlNode1 = mandlNode1;
        this.mandlNode2 = mandlNode2;
        this.travelTime = -1;
        this.demand = demand;
        this.pheromone = 0.0;
        this.probability = 0.0;
        this.edgeValue = 0.0;
        this.copy = false;
    }

    public MandlEdge(MandlEdge bestAntsChoice) {
        this.mandlNode1 = bestAntsChoice.getMandlNode1();
        this.mandlNode2 = bestAntsChoice.getMandlNode2();
        this.travelTime = bestAntsChoice.getTravelTime();
        this.demand = bestAntsChoice.getTravelTime();
        this.pheromone = bestAntsChoice.getPheromone();
        this.probability = bestAntsChoice.getProbability();
        this.edgeValue = bestAntsChoice.getProbability();
        this.copy = true;

    }

    public boolean isCopy() {
        return copy;
    }
    
    public double getEdgeValue() {
        return edgeValue;
    }

    public void setEdgeValue(double edgeValue) {
        this.edgeValue = edgeValue;
    }

    public double getProbability() {
        return probability;
    }

    public void setProbability(double probability) {
        this.probability = probability;
    }

    public double getPheromone() {
        return pheromone;
    }

    public void increasePheromone(double pheromone) {
        if(travelTime >= 0){
            double pheromoneToAdd = pheromone/travelTime;
            this.pheromone += pheromoneToAdd;
        } else {
            System.err.print("Adding: Chosen edge has no traveltime: Should never happen!");
        }
    }
    public void decreasePheromone(double percentOfPheromoneToRemain) {
        this.pheromone = this.pheromone*percentOfPheromoneToRemain;
    }

    public MandlNode getMandlNode1() {
        return mandlNode1;
    }

    public void setMandlNode1(MandlNode mandlNode1) {
        this.mandlNode1 = mandlNode1;
    }

    public MandlNode getMandlNode2() {
        return mandlNode2;
    }

    public void setMandlNode2(MandlNode mandlNode2) {
        this.mandlNode2 = mandlNode2;
    }

    public int getTravelTime() {
        return travelTime;
    }

    public void setTravelTime(int travelTime) {
        this.travelTime = travelTime;
    }

    public int getDemand() {
        return demand;
    }

    public String toString(){
        return "MandlNode:" + mandlNode1.getNumber() + " MandlNode:" + mandlNode2.getNumber() + " Demand: " + demand  + " Time: " + travelTime + " Pheromone: " + pheromone + " Probability: " + probability;
    }


}
