import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collections;
import java.util.SortedMap;

/**
 * Created by hanngu on 09.05.15.
 */
public class CalculationMain {



    public static void main(String[] args) {
        ArrayList<Double> seconds = new ArrayList<>();
        ArrayList<Double> listOfD0 = new ArrayList<>();
        ArrayList<Double> listOfD1 = new ArrayList<>();
        ArrayList<Double> listOfD2 = new ArrayList<>();
        ArrayList<Double> listOfDUnsat = new ArrayList<>();
        ArrayList<Double> listOfAtt = new ArrayList<>();
        ArrayList<Double> listOfTotfit = new ArrayList<>();
        ArrayList<Double> listOfPercent = new ArrayList<>();


        ArrayList<DummyAnt> bestAnts = new ArrayList<>();
        BufferedReader br = null;

        try {

            String sCurrentLine;

            br = new BufferedReader(new FileReader(("mumford1.txt")));

            while ((sCurrentLine = br.readLine()) != null) {
                if(bestAnts.size()<51) {
                    if (sCurrentLine.equals("*")) {

                        br.readLine();
                        double second = Double.parseDouble(br.readLine().substring(8));
                        seconds.add(second);

                        double totfit = Double.parseDouble(br.readLine().substring(16));
                        listOfTotfit.add(totfit);

                        double d0 = Double.parseDouble(br.readLine().substring(12));
                        listOfD0.add(d0);

                        double d1 = Double.parseDouble(br.readLine().substring(12));
                        listOfD1.add(d1);

                        double d2 = Double.parseDouble(br.readLine().substring(12));
                        listOfD2.add(d2);

                        double dUnsat = Double.parseDouble(br.readLine().substring(16));
                        listOfDUnsat.add(dUnsat);

                        double att = Double.parseDouble(br.readLine().substring(13));
                        listOfAtt.add(att);

                        /*double percent = Double.parseDouble(br.readLine().substring(72));
                        listOfPercent.add(percent);*/

                        String routeSet = br.readLine();

                        bestAnts.add(new DummyAnt(totfit, d0, d1, d2, dUnsat, att, routeSet));

                    }
                }
            }

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (br != null)br.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        //System.out.println("Number of iterations: " + bestAnts.size());
        //getStatisticsAttAndTotfit(listOfTotfit, listOfAtt, listOfPercent);
        System.out.println("***************************Using Totfit Comparator***************************");
        getStatistics(listOfD0, listOfD1, listOfD2, listOfDUnsat, listOfAtt, bestAnts, seconds, true);
        System.out.println("***************************Using ATT/D0 Comparator***************************");
        getStatistics(listOfD0, listOfD1, listOfD2, listOfDUnsat, listOfAtt, bestAnts, seconds, false);
        //double averageTotfit = calculateAverage(listOfTotfit);
        //System.out.println(averageTotfit);


    }


    private static void getStatisticsAttAndTotfit(ArrayList<Double> totfit, ArrayList<Double> att, ArrayList<Double> listOfPercent){
        Statistics statistics = new Statistics();
        Collections.sort(totfit, new DoubleComparator());

        Collections.sort(att, new DoubleComparator());

        double totfitAvg = statistics.round(calculateAverage(totfit),3);
        //double attAvg = calculateAverage(att);

        double totfitStd = statistics.round(calculateStandardDeviation(totfit, totfitAvg), 3);
        //double attStd = calculateStandardDeviation(att, attAvg);

        double totfitMarginOfError = statistics.round(calculateMarginOfError(1.96, totfitStd, totfit.size()), 3);
        //double attMarginOfError = calculateMarginOfError(1.96, attStd, att.size());

        double totfitRelativeStandardDeviation = statistics.round(((totfitStd/totfitAvg)*100),3);

        double percentAvg = statistics.round(calculateAverage(listOfPercent),3);

        double bestAnt = statistics.round(totfit.get(0),3);
        double worstAnt = statistics.round(totfit.get(totfit.size()-1), 3);


        System.out.println("~ & 10\\% & 10\\% & 0.0 & " + totfitAvg + " $\\pm$ " + totfitMarginOfError + " & "+ totfitStd +" & " + totfitRelativeStandardDeviation + " & " + bestAnt +" & " + worstAnt + "\\\\");

        /*System.out.println("Best ATT: " + att.get(0));
        System.out.println("Worst ATT: " + att.get(att.size()-1));
        System.out.println("Average ATT: " + attAvg);
        System.out.println("CI ATT: " + attAvg + "+/-" + attMarginOfError);
        System.out.println();
        System.out.println("Best TOTFIT: " + totfit.get(0));
        System.out.println("Worst TOTFIT: " + totfit.get(att.size()-1));
        System.out.println("Average TOTFIT: " + totfitAvg);
        System.out.println("CI TOTFIT: " + totfitAvg + "+/-" + totfitMarginOfError);*/
    }



    private static void getStatistics(ArrayList<Double> d0, ArrayList<Double> d1, ArrayList<Double> d2,
                                      ArrayList<Double> dUnsat, ArrayList<Double> att, ArrayList<DummyAnt> bestAnts,
                                      ArrayList<Double> seconds, boolean useTotfitComparator){
        //The one with highest totfit is at position 0

        Statistics statistics = new Statistics();

        if(useTotfitComparator){
            Collections.sort(bestAnts, new DummyAntTotfitComparator());
        } else{
            Collections.sort(bestAnts, new DummyAntBestAntComparator());
        }
        DummyAnt bestAnt = bestAnts.get(0);


        DummyAnt worstAnt = bestAnts.get(bestAnts.size()-1);

        double averageD0 = statistics.round(calculateAverage(d0), 2);
        double averageD1 = statistics.round(calculateAverage(d1), 2);
        double averageD2 = statistics.round(calculateAverage(d2), 2);
        double averageDUnsat = statistics.round(calculateAverage(dUnsat), 2);
        double averageAtt = statistics.round(calculateAverage(att), 2);


        Collections.sort(d0, new DoubleComparator());
        Collections.sort(d1, new DoubleComparator());
        Collections.sort(d2, new DoubleComparator());
        Collections.sort(dUnsat, new DoubleComparator());
        Collections.sort(att, new DoubleComparator());

        double medianD0 = statistics.round(calculateMedian(d0), 2);
        double medianD1 = statistics.round(calculateMedian(d1), 2);
        double medianD2 = statistics.round(calculateMedian(d2), 2);
        double mediandUnsat = statistics.round(calculateMedian(dUnsat), 2);
        double medianAtt = statistics.round(calculateMedian(att), 2);


        double standardDeviationD0 = statistics.round(calculateStandardDeviation(d0, averageD0), 2);
        double standardDeviationD1 = statistics.round(calculateStandardDeviation(d1, averageD1), 2);
        double standardDeviationD2 = statistics.round(calculateStandardDeviation(d2, averageD2), 2);
        double standardDeviationdUnsat = statistics.round(calculateStandardDeviation(dUnsat, averageDUnsat), 2);
        double standardDeviationAtt = statistics.round(calculateStandardDeviation(att, averageAtt), 2);


        Collections.sort(seconds, new DoubleComparator());
        double worstSeconds = seconds.get(seconds.size()-1);
        double bestSeconds = seconds.get(0);
        double averageSeconds = calculateAverage(seconds);
        double medianSeconds = calculateMedian(seconds);
        double standardDeviationSeconds = calculateStandardDeviation(seconds, averageSeconds);
        double relativeStandardDeviationSeconds = (standardDeviationSeconds/averageSeconds)*100;


        System.out.println("SSO Best & " + statistics.round(bestAnt.getD0(), 2)+ " & " +statistics.round(bestAnt.getD1(), 2) + " & " + statistics.round(bestAnt.getD2(), 2)
                + " & " + statistics.round(bestAnt.getdUnsat(), 2) + " & " + statistics.round(bestAnt.getAtt(), 2) +"\\\\");
        System.out.println("SSO Average & " + averageD0 + " & " + averageD1 + " & " + averageD2 + " & " + averageDUnsat + " & " + averageAtt +"\\\\");
        System.out.println("SSO Median & " + medianD0 + " & " + medianD1 + " & " + medianD2 + " & " + mediandUnsat + " & " + medianAtt +"\\\\");
        System.out.println("SSO Worst & " + statistics.round(worstAnt.getD0(), 2) + " & " + statistics.round(worstAnt.getD1(), 2) + " & "
                + statistics.round(worstAnt.getD2(), 2) + " & " + statistics.round(worstAnt.getdUnsat(), 2) + " & " + statistics.round(worstAnt.getAtt(), 2) +"\\\\");
        System.out.println("SSO Standard Deviation & " + standardDeviationD0 + " & " + standardDeviationD1 + " & " + standardDeviationD2 + " & " + standardDeviationdUnsat + " & " + standardDeviationAtt +"\\\\");

        System.out.println(bestAnt.getRouteSet());


    }

    private static double calculateMedian(ArrayList<Double> list) {
        double median;
        //if the list is even numbered
        if((list.size()&1)==0){
            double centralNumber1 = list.get((list.size()/2)-1);
            double centralNumber2 = list.get((list.size()/2));
            median = (centralNumber1+centralNumber2)/2.0;
        } else {
            median = list.get(((list.size()-1)/2));
        }
        return median;
    }

    private static double calculateAverage(ArrayList<Double> list) {
        double total = 0.0;
        for(Double d : list){
            total += d;
        }
        return total/list.size();
    }

    private static double calculateStandardDeviation(ArrayList<Double> list, double average) {
        double squareSum = 0.0;
        for(Double d : list){
            double temp = d - average;
            temp = Math.pow(temp, 2);
            squareSum += temp;
        }
        return Math.sqrt(squareSum/list.size());
    }

    private static double calculateMarginOfError(double confidenceCoefficient, double standardDeviation, int size) {
        return confidenceCoefficient * (standardDeviation/Math.sqrt(size));
    }


}
